# Modernizing Your Existing Adobe Experience Manager Sites Codebase

## Table of Contents

* [Lab Overview](../README.md#lab-overview)
* [Lesson 0 - Software Installation](lesson-0.md)
* [Lesson 1 - Editable Templates](lesson-1.md)
* [Lesson 2 - Component Updates](lesson-2.md)
* [Lesson 3 - Policy Updates](lesson-3.md)
* [Lesson 4 - Dialog Updates](lesson-4.md)
* [Troubleshooting Steps](../troubleshooting.md)
* [Next Steps](../next-steps.md)
* [Additional Resources](../additional-resources.md)

## Lesson 0 - Software/Content Installation

### Lesson Context

This lesson sets up the AEM and software necessary for the remaining lessons. This should already be done on the Summit Lab machines, but is listed here for repeating off-line.

### Exercise 0.1 - Content Package Installation

1. Open the *Terminal* application

2. Change the working directory to the `packages` folder:

```
$ cd ~/Desktop/Summit-2019/packages
```

3. Install the legacy default designs.

```
$ mvn com.day.jcr.vault:content-package-maven-plugin:install -Dvault.file=./default-design.zip

```  

4. Install the provided Geometrixx Shapes content package on both Author and Publish instance.

```
$ mvn com.day.jcr.vault:content-package-maven-plugin:install -Dvault.file=./cq-geometrixx-pkg-5.11.11-SNAPSHOT.zip
```  

5. Install the AEM Modernization Tool kit.

```
$ mvn com.day.jcr.vault:content-package-maven-plugin:install -Dvault.file=./aem-modernize-tools-content-0.0.1-SNAPSHOT.zip
```  
6. Install the Lab Demo code.
```
$ mvn com.day.jcr.vault:content-package-maven-plugin:install -Dvault.file=./summit-l761-geodemo.ui.apps-0.0.1-SNAPSHOT.zip
```

### Next Lesson

At this point you are ready to start working on the exercises for the lab.

[Start the next Lesson.](lesson-1.md)