# Modernizing Your Existing Adobe Experience Manager Sites Codebase

## Table of Contents

* [Lab Overview](../README.md#lab-overview)
* [Lesson 0 - Software Installation](lesson-0.md)
* [Lesson 1 - Editable Templates](lesson-1.md)
* [Lesson 2 - Component Updates](lesson-2.md)
* [Lesson 3 - Policy Updates](lesson-3.md)
* [Lesson 4 - Dialog Updates](lesson-4.md)
* [Troubleshooting Steps](../troubleshooting.md)
* [Next Steps](../next-steps.md)
* [Additional Resources](../additional-resources.md)


## Lesson 4 - Updating Classic Dialogs to Touch-enabled UI Dialogs

### Lesson Context

This lesson covers how to use the *Dialog Conversion Tool* for updating Classic Dialogs for a component. There is thorough documentation available (see [References](/README.md#references)) on how to use this tool. However, we'll go through the process in a controlled environment.

### Scenario

Now that the templates and components have been updated, we need to optimize the dialog for the Lead component for the Touch-enabled UI.

### Exercise 4.1 - Review Classic

Before we begin, lets take a look at the current dialog and how a Classic dialog appears on the Touch-enabled UI.

* Open the [Geometrixx Home Page](http://localhost:4502/editor.html/content/geometrixx/en.html) Bookmark in Chrome.

Make sure we're in edit mode.
<p align="center">
  <img src="/images/edit-mode.png" width="900px" /><br/>
  <em>Edit Mode</em>
  <br/>
  <br/>
</p>

Open the lead component's dialog on the Geometrixx home page.
<p align="center">
  <img src="/images/classic-dialog-1.png" width="900px" /><br/>
  <em>Lead Component Selection</em>
  <br/>
  <br/>
</p>

Review the rendering. You can see that it is an embedding of the classic dialog in a Touch UI wrapper.
<p align="center">
  <img src="/images/classic-dialog-2.png" width="600px" /><br/>
  <em>Lead Component Classic Dialog</em>
  <br/>
  <br/>
</p>


### Exercise 4.2 - Update the Dialog

We're going to identify the first dialog we want to migrate. In this case, it's the Geometrixx *Lead* component. We copied the original over to the new code base as an example.

* Open the [AEM Start Page](http://localhost:4502/aem/start.html) Bookmark in Chrome.

Navigate to the Dialog Conversion tool.
<p align="center">
  <img src="/images/dialog-conversion-1.png" width="900px" /><br/>
  <em>Dialog Conversion Navigation</em>
  <br/>
  <br/>
</p>


Search for the components with legacy dialogs. In this project's case, there is only one: our Lead component.
<p align="center">
  <img src="/images/dialog-conversion-2.png" width="900px" /><br/>
  <em>Dialog Conversion Search</em>
  <br/>
  <br/>
</p>

Select the lead component for conversion, and kick the process off.
<p align="center">
  <img src="/images/dialog-conversion-3.png" width="900px" /><br/>
  <em>Dialog Conversion Selection</em>
  <br/>
  <br/>
</p>


After it's done, you'll get the standard success message.
<p align="center">
  <img src="/images/dialog-conversion-4.png" width="900px" /><br/>
  <em>Dialog Conversion Success</em>
  <br/>
  <br/>
</p>

### Exercise 4.3 - Review the Updates

With the dialog conversion complete, we can take a look at the new dialog.

* Open the [Geometrixx Home Page](http://localhost:4502/editor.html/content/geometrixx/en.html) Bookmark in Chrome.

Select the Lead component and open it's dialog again.
<p align="center">
  <img src="/images/coral3-dialog-1.png" width="900px" /><br/>
  <em>Lead Component Selection</em>
  <br/>
  <br/>
</p>

As you can see, it now renders using the much cleaner Coral 3 widgets.
<p align="center">
  <img src="/images/coral3-dialog-2.png" width="600px" /><br/>
  <em>Lead Component Coral3 Dialog</em>
  <br/>
  <br/>
</p>

  
### Next Steps

Take a look at the [next steps](/next-steps.md) section for where to go from here.
