# Modernizing Your Existing Adobe Experience Manager Sites Codebase

## Table of Contents

* [Lab Overview](README.md#lab-overview)
* [Lesson 0 - Software Installation](lessons/lesson-0.md)
* [Lesson 1 - Editable Templates](lessons/lesson-1.md)
* [Lesson 2 - Component Updates](lessons/lesson-2.md)
* [Lesson 3 - Policy Updates](lessons/lesson-3.md)
* [Lesson 4 - Dialog Updates](lessons/lesson-4.md)
* [Troubleshooting Steps](troubleshooting.md)
* [Next Steps](next-steps.md)
* [Additional Resources](additional-resources.md)

## Next Steps

In this lab, we provided an overview of the tools created to assist in migrating AEM pages, templates, and components to modern capabilities. From here, customers can begin planning projects to apply these tools to their current implementations. You can:

  * Evaluate current static templates with a view for Editable Template structure.
  * Review current component suite for compatibility with Core Components
  * Inventory classic component dialogs for upgrade to Coral 3 versions. 
  
With this information in hand, you can create custom conversion rules. Use them on a proof-of-concept application to begin your AEM Modernization effort!
